100 remark $$chan=6
102 remark $$stak=800
104 remark $$asmb=dev4_toox_dos_rxt_DOX_CDE,0,16
106 remark $$asmb=dev4_toox_dos_rxt_MEN_CDE,0,16
108 :
110 ext_proc 'QUICKSORT', 'QLIBJN'
112 ext_fn 'DETAB$', 'VALID%', 'WPARSE$', 'WIRX%', 'ODD'
114 ext_fn 'MN_DOX', 'MN_QSEL', 'SP_A', 'SP_Z'
116 ext_fn 'CF_POX$', 'CF_ANC%', 'CF_FIX%'
118 :
120 rem     To compile on QPC2
122 ext_proc "NFA_USE": ext_fn "NFA_USE$"
124 :
126 rem     To compile on SMSQmulator
128 ext_proc "DOS_DRIVE": ext_fn "DOS_DRIVE$", "QPC_VER$"
130 :
132 :
134 rem + ------------------------------------------------------------------------ +
136 rem |<                              DOS Selector                              >|
138 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
140 rem | Host OS device browser and file name selector                            |
142 rem | Designed to be called by another program                                 |
144 rem | Result returned at given address (if any) and in stuffer buffer          |
146 rem | For QPC2 v4+ and SMSQmulator v2.24+ with SMSQ/E 3.31+, under Windows     |
148 rem + ------------------------------------------------------------------------ +
150 rem | V0.14 2020 Feb 04, See history                                           |
152 rem | V0.15 2024 Apr 26, Improved get palette, improved parsing filespec, etc  |
154 rem + ------------------------------------------------------------------------ +
156 :
158 rem Init init
160 restore
162 qlibed = 1:                     rem Compiled = 1
164 dim title$(18):                 rem Max title length
166 :
168 rem $$off
170 if peek$(\\ -4, 4) = 'SBAS' then
172  qlibed = 0
174  rem MN_DOX = LDATA(home_dir$  & 'dox_men')
176  lrespr home_dir$ & 'rxt_DOX_CDE'
178  lrespr home_dir$ & 'rxt_MEN_CDE'
180 endif
182 rem $$on
184 :
186 rem *** Changes due to SMSQmulator ***
188 fix% = 0:                       rem Dont translate extension seperators
190 mach% = machine
192 sel on mach%
194  = 20: rem SMSQmulator
196    dev$ = 'NFA': dev% = 2
198  = 30: rem QPC2
200    dev$ = 'DOS': dev% = 1
202    if QPC_VER$ > '4.05': fix% = CF_FIX%
204  = remainder: dev% = 0
206 endsel
208 use$ = DevGetUse$(dev$)
210 :
212 rem     Program Configuration
214 drv%            = cf_anc%:      rem Drive number to use
216 maxd%           = 199:          rem Max dir len under QPC2
218 ymin%           = 120:          rem Main window min y size
220 awmin%          =  70:          rem AW min size
222 xsize%          = 250:          rem Window width
224 ysize%          = ymin%:        rem Current y size
226 :
228 rem     Constants
230 ww_nappl        = 110:          rem .w  $6e  number of application sub-windows
232 ww_pappl        = 112:          rem .l  $70  pointer to application sub-window definition list
234 ww_ysize        =  34:          rem .w  $22  window y size (height) in pixels
236 ww_xorg         =  36:          rem .w  $24  x origin of window
238 :
240 wwa_borc        =   4:          rem .w  $04  border colour
242 wwa_watt        =   8:          rem     $08       sub-window attributes
244 wwa_part        =  40:          rem .l  $28  pointer to the part window control block (or 0)
246 wwa_psac        =  64:          rem .w  $40  pan or scroll arrow colour
248 wwa_psbc        =  66:          rem .w  $42  pan or scroll bar colour
250 wwa_pssc        =  68:          rem .w  $44  pan or scroll bar section colour
252 wwa_clen%       =  30:          rem     $1e  - application sub-window control definition length
254 :
256 sp_infwinbg%    = 527:          rem Information window background
258 sp_infwinfg%    = 528:          rem Information window foreground
260 sp_titletextbg% = 517:          rem Title text background
262 sp_titlefg%     = 518:          rem Title foreground
264 :
266 sp_appbd%       = 534:          rem Application window border
268 sp_scrbar%      = 545:          rem Pan/scroll bar
270 sp_scrbarsec%   = 546:          rem Pan/scroll bar section
272 sp_scrbararr%   = 547:          rem Pan/scroll bar arrow
274 :
276 esc%            =  27:          rem ESC code
278 quote$          = '"' & "'":    rem Quote charcters
280 sep$            = '\':          rem DOS seperator altered to / if linux
282 dots$           = '..':         rem Compact directory place holder
284 :
286 rem Various Easyptr metrics
288 iw_mess%        =     3:        rem IW Message window ID
290 aw_wmov%        =     1:        rem AW Move ID
292 aw_disp%        =     2:        rem AW Display ID
294 li_filt%        =    -5:        rem LI Filter
296 li_sort%        =    -6:        rem LI Sort
298 we_wake%        = -1088:        rem Return code for Wake
300 we_wmov%        = -1032:        rem Return code for Move event
302 mvec%           =    11:        rem Call vectors
304 irt%            =    48:        rem Immediate return
306 width%          =    38:        rem Display width in char
308 rem $$f
310 :
312 mencon          =  2^16:        rem Long word multiplier
314 dim pv%(16)
316 :
318 dim attr$(8), sortc$(4, 6), sorth$(4, 12), sorts%(4)
320 attr$           = 'XXADVSHR':   rem DOS attributes
322 devl%           =   3:          rem Device directory level
324 for i% = 0 to 4: read sortc$(i%), sorth$(i%)
326 data '<none>', '', 'Name', '', 'Date', ''
328 data 'Size', 'File length', 'Attr', 'Attributes'
330 :
332 popfnm$ = cf_pox$
334 if popfnm$ = '' or popfnm$ == 'POX_obj' then
336  popfnm$ = home_dir$ & 'Pox_obj'
338 endif
340 poxx = ftest(popfnm$)
342 :
344 cw = fopen("con_"): cw% = cw
346 :
348 rem Parse Commandline
350 dosspec$ = GetFSSpec$: rem Discover file system (for now)
352 ert GetCmd(CMD$)
354 :
356 REMark Start
358 PalSet
360 SetUse
362 :
364 if dev% then
366  if ddir$ = '' then
368   Devices
370  else
372   DIRload ddir$: Sort: rem No error checking..
374  endif
376  sorts%(sort%) = 128
378 endif
380 :
382 Redraw xpos%, ypos%, xsize%, awmin% + count% * 11
384 :
386 if dev% = 0: ErrMess 'Device not supported': quit -7
388 :
390 Refresh
392 st% = 0: row% = -1: col% = -1
394 :
396 :
398 rem Main action loop
400 rep main
402  k = mcall(#cw%, k, st%)
404  pval#cw%; pv%
406  use$ = DevGetUse$(dev$): DoTitle
408  sel on k
410  = -1: Resize
412        row% = -1: col% = -1
414  = -2, we_wake%: WakeUp pv%(5): rem Refresh/Wake
416  rem = -3: Internal sleep
418  = -4: exit main: rem No return info
420  = li_filt%: Filter
422  = li_sort%: ReSort
424  = aw_wmov%: if pv%(5) instr '12': wmov#cw%; -1
426  = we_wmov%: wmov#cw%; -1
428  = mencon to 1e9: rem File list
430    :
432    rdpt#cw%; 4, -1, -1, 10: rem Delay: key up or timeout
434    row% = k / mencon - 1: rem row% = row: rem Qlib!
436    if row% = 0 then
438     UpDirectory
440    else
442     if row% >= 0 and row% <= count% then
444      rem row% could be -1?
446      if type%(row%) = 255 then
448       DoDirectory
450      else
452       if DoFilename: exit main
454      endif
456     endif
458    endif
460  endsel
462  st% = 0
464 endrep main
466 ptop#cw%; ojob(jobid): quit 0
468 :
470 :
472 rem + ------------------------------------------------------------------------ +
474 rem |<                              Subroutines                               >|
476 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
478 rem | The following routines all use main GLOBal values, although the may      |
480 rem | have their own LOCals                                                    |
482 rem |                                                                          |
484 rem + ------------------------------------------------------------------------ +
486 :
488 def proc UpDirectory
490 if pv%(5) = 2 then
492  Devices
494 else
496  DirUp
498 endif
500 Refresh
502 Mess Compact$(ddir$, width%)
504 enddef UpDirectory
506 :
508 def proc DoDirectory
510 loc lv, c%,  rt$, ort$
512 :
514 if pv%(5) = 2 then
516  rem Down directory
518  if ddir$ = '' then
520   rem Top level: Use actual drive info
522   if nms$(row%) = '': Burp: ret
524   sel on dev%
526    = 1: Dnd DOS_DRIVE$(row%)
528    = 2: Dnd NFA_USE$(row%)
530   endsel
532  else
534   Dnd nms$(row%)
536  endif
538  DIRLoad ddir$: Sort
540  Refresh
542  Mess Compact$(ddir$, width%)
544 else
546  rem HIT on directory
548  if ddir$ = '' then
550   rem Top level: Edit DOS drive
552   sel on dev%
554    = 1: ort$ = detab$(DOS_DRIVE$(row%))
556    = 2: ort$ = detab$(NFA_USE$(row%))
558         if ort$ = sep$: ort$ = ''
560   endsel
562   if len(ort$) > 40 then
564    ErrMess 'Name too long to edit in DOX': ret
566   endif
568   rt$ = ort$
570 :
572   rem Edit until valid or ESC
574   mwindow#cw%, k
576 :
578   rep lv
580    minput#cw%; rt$
582    if mkey%(#cw%) = esc%: exit lv
584    rt$ = detab$(rt$)
586    if rt$ = '' and dev% = 1 then
588     rt$ = ' '
590    else
592     if not WIRX%(dosspec$, rt$): Burp: next lv
594     rem For aesthetic reasons on DOS type filespec..
596     if sep$ = '\' then
598      c% = code(rt$(1))
600      sel on c%: = 97 to 122: rt$ = chr$(c% - 32) & rt$(2 to len(rt$)): endsel
602     endif
604    endif
606    sel on dev%
608     = 1: DOS_DRIVE row%, rt$
610     = 2: NFA_USE row%, rt$
612    endsel
614    er = ftest(use$ & row% & '_')
616    if er = 0 or er = -7: exit lv:       rem -7 => valid but not present
618    Burp
620    rem Bad filespec; revert
622    sel on dev%
624     = 1: DOS_DRIVE row%, ort$
626     = 2: NFA_USE row%, ort$
628    endsel
630   endrep lv
632   WakeUp 1
634   Ping: rdpt#cw%; 4: rem Dont just dash down the rabbit hole!
636  :
638  else
640   Mess GetDate$(dates(idx%(row%))) & ' | ' & Attrib$(attrib%(idx%(row%))) & ' | ' & cdec$(length(idx%(row%)), 12, 0)
642   Tail: hot_stuff ddir$ & nms$(idx%(row%))
644   Popup ddir$ & nms$(idx%(row%))
646   if fstat% then
648    Mess '' & dimn(disp$) & ' of ' & count% & ' items'
650   else
652    Mess 'Dirs: ' & dirc% & ', Files: ' & filec% & ', Total: ' & count%
654   endif
656  endif
658 endif
660 enddef DoDirectory
662 :
664 def fn DoFilename
666 loc rt$(198)
668 Tail
670 if pv%(5) = 1 then
672  rem HIT => info
674  rem QPC_EXEC ddir$ & nms$(row%): rem Set by Zwitch?
676  Mess GetDate$(dates(idx%(row%))) & ' | ' & Attrib$(attrib%(idx%(row%))) & ' | ' & cdec$(length(idx%(row%)), 12, 0)
678  hot_stuff ddir$ & nms$(idx%(row%))
680  Popup ddir$ & nms$(idx%(row%))
682  if fstat% then
684   Mess '' & dimn(disp$) & ' of ' & count% & ' items'
686  else
688   Mess 'Dirs: ' & dirc% & ', Files: ' & filec% & ', Total: ' & count%
690  endif
692  ret 0
694 else
696  rem DO stuff and quit
698  rt$ = ddir$ & nms$(idx%(row%))
700 :
702  rem Poke and/or stuff
704  hot_stuff rt$
706  if retadd then
708   poke_w retadd, len(rt$)
710   poke$ retadd + 2, rt$
712  endif
714  ret 1
716 endif
718 enddef DoFilename
720 :
722 def proc ReSort
724 loc ns%
726 if pv%(5) = 1 then
728  if azza% = 1 then
730   azza% = -1
732   mitem#cw%; li_sort%, -2, SP_Z
734  else
736   azza% = 1
738   mitem#cw%; li_sort%, -2, SP_A
740  endif
742 else
744  rem Quicksel sort criteria
746  ns% = QuickSel(xsize% - 36, 42, sortc$, sorth$, sorts%, 1)
748  sel on ns%
750   = -1: rem Esc
752         sorts%(0) = 0
754   = -2: rem No sort
756         sorts%(sort%) = 0: sort% = 0: sorts%(sort%) = 129
758   = remainder: rem Everything else
760         if sort% <> ns% then
762          sorts%(sort%) = 0: sort% = ns%
764         endif
766  endsel
768 endif
770 WakeUp 1: rem Refresh
772 enddef ReSort
774 :
776 def proc Filter
778 if pv%(5) = 1 then
780  fstat% = not fstat%
782  st% = fstat%
784 else
786  mwindow#cw%, k
788  minput#cw%; filt$
790  if len(filt$) = 0: filt$ = '*'
792  mitem#cw%, li_filt%, 0, filt$
794  filtp$ = WPARSE$(filt$)
796  fstat% = 1: st% = fstat%
798 endif
800 Refresh
802 mawdraw#cw%; aw_disp%
804 rem Refresh
806 Mess '' & dimn(disp$) & ' of ' & count% & ' items'
808 enddef Filter
810 :
812 :
814 rem + ------------------------------------------------------------------------ +
816 rem |<                       Various Display Procedures                       >|
818 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
820 rem |                                                                          |
822 rem + ------------------------------------------------------------------------ +
824 :
826 def proc DoTitle
828 SetUse
830 Title aw_wmov%, title$
832 enddef DoTitle
834 :
836 def proc SetUse
838 jobname$ = 'DOX ' & use$ & drv% & '_'
840 if ftitle = 0: title$ = jobname$
842 :
844 if qlibed then
846  qlibjn jobname$
848 else
850  job_name jobname$
852 endif
854 enddef SetUse
856 :
858 def proc Redraw(xp%, yp%, xs%, ys%)
860 rem GLOBal cw%, cm%, st%, azza%,..
862 :
864 if wsize% then
866  mdraw#cw%; mn_dox, xp%, yp%, xs%, awmin% + wsize% * 11
868 else
870  mdraw#cw%; mn_dox, xp%, yp%, xs%, ys%
872 endif
874 :
876 mitem#cw%, li_filt%, 0, filt$
878 if azza% = -1 then
880  mitem#cw%; li_sort%, -2, SP_Z
882 else
884  mitem#cw%; li_sort%, -2, SP_A
886 endif
888 :
890 st% = mstat%(#cw%, li_filt%, fstat%)
892 mwindow#cw%, 0
894 enddef Redraw
896 :
898 def proc Refresh
900 loc i%, j%, ic%
902 if fstat% = 0 or ddir$ = '' then
904  rem Refresh unfiltered from source arrays
906  :
908  dim disp$(count%, width%)
910  :
912  if ddir$ = '' then
914   for i% = 1 to 8
916    disp$(i%) = i% & ' ' & nms$(i%)
918   endfor i%
920  else
922   for i% = 1 to count%
924    if type%(i%) = 255 then
926     disp$(i%) = '> ' & nms$(i%)
928    else
930     disp$(i%) = nms$(i%)
932    endif
934    idx%(i%) = i%: rem Reset index
936   endfor i%
938  endif
940 else
942 :
944  rem Refresh filtered from source arrays
946  rem Includes all directories plus pattern-matched filenames
948  ic% = 0
950  rem Count
952  for i% = 1 to count%
954   if WIRX%(filtp$, nms$(i%)) or type%(i%) = 255 then
956    ic% = ic% + 1
958    idx%(ic%) = i%
960   endif
962  endfor i%
964  dim disp$(ic%, width%)
966 :
968  j% = 1
970  for i% = 1 to ic%
972   if type%(idx%(i%)) = 255 then
974    disp$(j%) = '> ' & nms$(idx%(i%))
976   else
978    disp$(j%) = nms$(idx%(i%))
980   endif
982   j% = j% + 1
984  endfor i%
986 endif
988 :
990 disp$(0) = sep$
992 :
994 mawsetup#cw%, aw_disp%, disp$
996 ARROW_BAR cw%
998 mdraw#cw%: Title aw_wmov%, title$
1000 rem mawdraw#cw%, aw_disp%
1002 enddef Refresh
1004 :
1006 def proc WakeUp(clk%)
1008 rem GLOBal cw%, cm%, ddir$, and global variables
1010 :
1012 rem If HIT reload directory, if DO, also redraw
1014 :
1016 if ddir$ = '' then
1018  Devices
1020 else
1022  DIRload ddir$: Sort
1024 endif
1026 :
1028 if clk% = 2 then
1030  mclear#cw%
1032  Redraw pv%(10), pv%(11), xsize%, pv%(9)
1034  Title aw_wmov%, title$
1036 endif
1038 :
1040 rem mawclear#cw%, aw_disp%
1042 Refresh
1044 enddef WakeUp
1046 :
1048 def proc Title(aw%, txt$)
1050 loc l%
1052 mwindow#cw%, aw%
1054 l% = len(txt$) * 6
1056 :
1058 wm_block#cw%; l% + 8, 11, (114 - l%) div 2 - 2, 2, sp_titletextbg%
1060 wm_strip#cw%; sp_titletextbg%
1062 wm_ink#cw%; sp_titlefg%
1064 cursor#cw%; (114 - l%) div 2 + 2, 3
1066 bput#cw%; txt$
1068 wm_paper#cw%; sp_infwinbg%
1070 wm_ink#cw%; sp_infwinfg%
1072 enddef Title
1074 :
1076 def proc Mess(tx$)
1078 mwindow#cw%; iw_mess%! 0
1080 wm_paper#cw%; sp_infwinbg%: wm_ink#cw%; sp_infwinfg%
1082 cls#cw%: cursor#cw%; 0, 1: bput#cw%; tx$
1084 enddef Mess
1086 :
1088 def proc ErrMess(txt$)
1090 Burp: Mess txt$: pause#cw; 100
1092 enddef ErrMess
1094 :
1096 :
1098 def proc Resize
1100 loc x%, y%, wwd
1102 rem Uses caller's locals
1104 if pv%(5) = 1 or pv%(6) = 241 then
1106  wsize#cw%; x%, y%
1108  :
1110  if pv%(6) = 241 then
1112   rem CTRL F3 workaround
1114   wwd = mwdef(#cw%)
1116   ysize%  = peek_w(wwd + ww_ysize)
1118   pv%(10) = peek_w(wwd + ww_xorg)
1120  else
1122   ysize% = pv%(9): rem Doesnt work if CF3 pressed!
1124  endif
1126  :
1128  if (ysize% - y%) < ymin%: y% = ysize% - ymin%
1130  ysize% = ysize% - y%
1132  pv%(11) = pv%(11) + y%
1134 else
1136  ysize% = awmin% + dimn(disp$) * 11
1138 endif
1140 wsize% = 0: rem Unset fixed window size
1142 :
1144 mclear#cw%
1146 Redraw pv%(10), pv%(11), xsize%, ysize%
1148 rdpt#cw%; irt%: pval#cw%; pv%
1150 Refresh
1152 enddef Resize
1154 :
1156 :
1158 rem + ------------------------------------------------------------------------ +
1160 rem |<                              Arrow / Bar                               >|
1162 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1164 rem | Routine to set MAW arrow and bar colour, omitted by EasyPointer          |
1166 rem |                                                                          |
1168 rem | V0.00, Bob Spelten                                                       |
1170 rem | V0.01, pjw, November 7th 2017                                            |
1172 rem + ------------------------------------------------------------------------ +
1174 :
1176 DEFine PROCedure ARROW_BAR (chn%)
1178 LOCal ii%, ofs%, wrkd, alst, appw
1180  wrkd= MWDEF(#chn%)
1182  alst= PEEK_L(wrkd +ww_pappl):                          REM find appl-work list
1184 :
1186  rem For each MAW (if none, skip this)
1188  FOR ii% =0 TO PEEK_W(wrkd +ww_nappl) - 1
1190    appw= PEEK_L(alst + 4 * ii%):                        REM appw -> each appl-work defn
1192    POKE_W appw + wwa_watt + wwa_borc, sp_appbd%:        rem set border colour
1194 :
1196    REM For each pan/scroll control section (wwa_clen% bytes long)
1198    for ofs% = 0 to wwa_clen% step wwa_clen%
1200     IF PEEK_L(appw +wwa_part + ofs%) then
1202       POKE_W appw +wwa_psac + ofs%, sp_scrbararr%:      REM pan arrow colour
1204       POKE_W appw +wwa_psbc + ofs%, sp_scrbar%:         rem pan bar colour
1206       POKE_W appw +wwa_pssc + ofs%, sp_scrbarsec%:      REM pan section colour
1208     END IF
1210    endfor ofs%
1212  END FOR ii%
1214 END DEFine ARROW_BAR
1216 :
1218 :
1220 rem + ------------------------------------------------------------------------ +
1222 rem |<                 Various Directory and Data Procedurers                 >|
1224 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1226 rem |                                                                          |
1228 rem + ------------------------------------------------------------------------ +
1230 :
1232 def proc Devices
1234 rem GLOBal nms$, type%,..
1236 rem GLOBal count%, ddir$
1238 count% = 8
1240 dim nms$(count%, 40), type%(count%), attrib%(count%), length(count%), dates(count%)
1242 sel on dev%
1244  = 1
1246  for i% = 1 to count%
1248   nms$(i%) = Compact$(DOS_DRIVE$(i%), width%)
1250   type%(i%) = 255
1252  endfor i%
1254  = 2
1256  for i% = 1 to count%
1258   if NFA_USE$(i%) = sep$ then
1260    nms$(i%) = ''
1262   else
1264    nms$(i%) = Compact$(NFA_USE$(i%), width%)
1266   endif
1268   type%(i%) = 255
1270  endfor i%
1272 endsel
1274 :
1276 nms$(0) = sep$: type%(0) = 256
1278 ddir$ = '': rem Current
1280 enddef Devices
1282 :
1284 def proc DIRLoad(d$)
1286 LOCal cl, fl, lv, drv$(6), n$(36), cf%, a%, t%
1288 loc c, l, pos, fln, od$(200)
1290 REMark GLOBal drv% - count%
1292 :
1294 drv$ = use$ & drv% & '_'
1296 rep lv
1298  sel on dev%
1300   = 1
1302     od$ = DOS_DRIVE$(drv%)
1304     DOS_DRIVE drv%, d$
1306     if ftest(drv$) = 0: exit lv
1308     if WIRX%(dosspec$, d$) and d$ <> ' ' then
1310      Upd d$: DOS_DRIVE drv%, d$
1312      if ftest(drv$) = 0: exit lv
1314     endif
1316     DOS_DRIVE drv%, od$: d$ = ''
1318     ErrMess 'Drive not present'
1320     ret
1322    endrep lv
1324   = 2
1326     od$ = NFA_USE$(drv%)
1328     NFA_USE drv%, d$
1330     if ftest(drv$) = 0: exit lv
1332     if WIRX%(dosspec$, d$) and d$ <> '' then
1334      Upd d$: NFA_USE drv%, d$
1336      if ftest(drv$) = 0: exit lv
1338     endif
1340     NFA_USE drv%, od$: d$ = ''
1342     ErrMess 'Drive not present'
1344     ret
1346    endrep lv
1348 endsel
1350 :
1352 rem First: count
1354 c = 0
1356 cf% = FOP_DIR(drv$)
1358 if cf% < 0 then
1360  sel on dev%
1362   = 1: DOS_DRIVE drv%, od$
1364   = 2: NFA_USE drv%, od$
1366  endsel
1368  quit cf%: rem Bail out - no error msg for now
1370 endif
1372 :
1374 pos = -64: fln = flen(#cf%)
1376 REPeat cl
1378  pos = pos + 64
1380  IF pos >= fln THEN
1382   REMark Done. No more names here
1384   exit cl
1386  ELSE
1388   GET#cf%\ pos + 14; n$
1390   IF LEN(n$) > 0: c = c + 1
1392  END IF
1394 END REPeat cl
1396 :
1398 rem Avoid swamping error
1400 if c > 32766 then
1402  count% = 32766
1404  ErrMess 'Showing first 32766 entries only!'
1406 else
1408  count% = c
1410 endif
1412 c = 0
1414 :
1416 rem Now read
1418 dim nms$(count%, 36), type%(count%), attrib%(count%), length(count%), dates(count%)
1420 dim idx%(count%): rem Use indirect reference to (filtered) items
1422 for t% = 0 to count%: idx%(t%) = t%: rem Create unfiltered index
1424 nms$(c) = sep$: type%(c) = 256
1426 dirc% = 0: filec% = 0
1428 get#cf%\ 0: pos = -64:
1430 REPeat fl
1432  pos = pos + 64: if pos >= fln: exit fl
1434  GET#cf%\ pos + 14; n$
1436  IF LEN(n$) = 0: next fl
1438 :
1440  REMark Valid name found
1442  c = c + 1: if c > count%: exit fl
1444  BGET#cf%\ pos + 4, a%, t%
1446  LGET#cf%\ pos + 0; l
1448  LGET#cf%\ pos + 52; dates(c)
1450  length(c) = l - 64
1452  if t% = 255 then
1454   dirc% = dirc% + 1
1456   if len(d$ & n$) >= maxd%: a% = a% + 256
1458  else
1460   filec% = filec% + 1
1462   if fix%: FixExtSep n$
1464  endif
1466  nms$(c) = n$
1468  attrib%(c) = a%
1470  type%(c) = t%
1472 END REPeat fl
1474 sel on dev%
1476  = 1: DOS_DRIVE drv%, od$
1478  = 2: NFA_USE drv%, od$
1480 endsel
1482 close#cf%
1484 enddef DIRLoad
1486 :
1488 def proc FixExtSep(nm$)
1490 loc i%
1492 for i% = len(nm$) to 1 step -1
1494  if nm$(i%) = sep$: exit i%: rem No ext sep found
1496  if nm$(i%) = '_' then
1498   nm$(i%) = '.'
1500   if ftest(drv$ & nm$) = 0: exit i%
1502   nm$(i%) = '_': exit i%
1504  endif
1506 endfor i%
1508 enddef FixExtSep
1510 :
1512 def proc DirUp
1514 rem Up directory
1516 l% = len(ddir$)
1518 Upd ddir$
1520 if l% <> len(ddir$) then
1522  DIRLoad ddir$: Sort
1524 else
1526  Devices
1528 endif
1530 enddef DirUp
1532 :
1534 DEFine PROCedure Upd(d$)
1536 rem Truncate string at previous dir level
1538 rem (This routine will probably fail on non-DOS!)
1540 LOCal i%, p%
1542 p% = 0
1544 FOR i% = LEN(d$) TO 1 STEP -1
1546  IF d$(i%) = sep$: p% = i%: EXIT i%
1548 END FOR i%
1550 IF p% > 0: d$ = d$(1 TO p% - 1)
1552 if len(d$) and d$ <> ' ' then
1554  if d$(len(d$)) instr '~:' & sep$: d$ = d$ & sep$
1556 endif
1558 END DEFine Upd
1560 :
1562 def proc Dnd(n$)
1564 Tail
1566 if len(ddir$ & n$) <= maxd%: ddir$ = ddir$ & n$
1568 enddef Dnd
1570 :
1572 def proc Tail
1574 if len(ddir$) > 0 then
1576  if ddir$(len(ddir$)) <> sep$: ddir$ = ddir$ & sep$
1578 endif
1580 enddef Tail
1582 :
1584 def proc Sort
1586 if ddir$ = '': ret: rem Dont sort devices
1588 sel on sort%
1590  = 0: rem No sort
1592  = 1: QUICKSORT type%; -1, nms$; azza%, attrib%; 0, length; 0, dates; 0
1594  = 2: QUICKSORT type%; -1, dates; azza%, nms$; 0, attrib%; 0, length; 0
1596  = 3: QUICKSORT type%; -1, length; azza%, nms$; 0, attrib%; 0, dates; 0
1598  = 4: QUICKSORT type%; -1, attrib%; azza%, nms$; 0, length; 0, dates; 0
1600 endsel
1602 enddef Sort
1604 :
1606 def fn GetDate$(dt)
1608 loc d$(20)
1610 if dt = 0: ret " ": rem fill$("-", 12)
1612 d$ = date$(dt)
1614 ret d$(10 to 11) & d$(5 to 9) & d$(3 to 5) & d$(13 to 17)
1616 enddef GetDate$
1618 :
1620 def fn Attrib$(a%)
1622 loc i%, a$(8)
1624 rem GLOBal attr$
1626 a$ = bin$(a%, 8)
1628 for i% = 1 to 8
1630  if a$(i%) = '0' then
1632   a$(i%) = '-'
1634  else
1636   a$(i%) = attr$(i%)
1638  endif
1640 endfor i%
1642 ret a$
1644 end def Attrib$
1646 :
1648 DEFine FuNction Compact$(n$, w%)
1650 LOCal i%, l%, p%, ml%, ld%
1652 REMark Compact directory
1654 REMark pjwitte 2oo2
1656 REMark V0.01
1658 :
1660 l% = LEN(n$)
1662 IF l% <= w%: RETurn n$
1664 p% = 1
1666 FOR i% = l% TO 1 STEP -1
1668  IF n$(i%) = sep$: p% = i%: EXIT i%
1670 END FOR i%
1672 ml% = l% - p% + devl% + 2
1674 IF ml% >= w% THEN
1676  IF p% <= devl%: RETurn n$(1 TO w% - 2) & dots$
1678  RETurn n$(1 TO devl%) & dots$ & n$(p% TO p% + w% - 8) & dots$
1680 END IF
1682 ld% = devl%
1684 FOR i% = ld% + 1 TO p% - 1
1686  IF n$(i%) = sep$ THEN
1688   IF (i% + ml%) > w%: EXIT i%
1690   ld% = i%
1692  END IF
1694 END FOR i%
1696 RETurn n$(1 TO ld%) & dots$ & n$(p% TO l%)
1698 END DEFine Compact$
1700 :
1702 :
1704 REMark Given real device name, return usage
1706 REMark SMSQ/E 3+
1708 REMark V0.03  May 7th 2014
1710 REMark V0.04, June 28th 2017, sans PEEK(!! )
1712 REMark V0.06, December 18th 2018, Check string length
1714 :
1716 DEFine FuNction DevGetUse$(real$)
1718 LOCal gdl, p, l%
1720 p = PEEK_L(VER$(-2) + 72)
1722 REPeat gdl
1724 :
1726  IF PeekStrg$(p + 42) == real$ THEN
1728   RETurn PeekStrg$(p + 36)
1730  END IF
1732 :
1734  p = PEEK_L(p): IF p = 0: EXIT gdl
1736 END REPeat gdl
1738 RETurn real$
1740 END DEFine DevGetUse$
1742 :
1744 :
1746 DEFine FuNction PeekStrg$(ad)
1748 l% = PEEK_W(ad)
1750 SELect ON l%: = 1 TO 4: RETurn PEEK$(ad + 2, l%)
1752 RETurn ''
1754 END DEFine PeekStrg$
1756 :
1758 :
1760 rem + ------------------------------------------------------------------------ +
1762 rem |<                               GetFSSpec$                               >|
1764 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1766 rem | Get File System Specification                                            |
1768 rem | Tries to work out whether were running under FAT/NTFS or Some *UX FS     |
1770 rem | 1. Assume WIN or DOS/NFA is always present                               |
1772 rem | 2. If specification fits FAT then its FAT                                |
1774 rem | 3. Otherwise it *UX or Unknown                                           |
1776 rem | This routine could be much improved, but hopefully the need for it will  |
1778 rem | one day disappear..                                                      |
1780 rem |                                                                          |
1782 rem | Sets GLOBal sep$                                                         |
1784 rem + ------------------------------------------------------------------------ +
1786 rem | V0.01, pjw, 2017 Jul 17                                                  |
1788 rem | V0.02, pjw, 2019 Jul 29, found a new DOS filename pattern!               |
1790 rem | V0.03, pjw, 2023 Apr 30, Improved algorithm?                             |
1792 rem + ------------------------------------------------------------------------ +
1794 :
1796 def fn GetFSSpec$
1798 loc i, f, s$(30)
1800 s$ = WPARSE$('?:\*;\\*\*'): rem Pattern of DOS path
1802 sep$ = '\'
1804 :
1806 f = 0
1808 for i = 1 to 8
1810  if not win_drive$(i) instr ' ' then:              rem Includes ''!
1812   if WIRX%(s$, WIN_DRIVE$(i)): f = 1: exit i: rem DOS found
1814  endif
1816 endfor i
1818 :
1820 if f = 0 then
1822  rem No valid WIN drives; try other type(s)
1824  sel on dev%
1826   = 1
1828     for i = 1 to 8
1830      if not DOS_DRIVE$(i) instr ' ' then
1832       if WIRX%(s$, DOS_DRIVE$(i)): f = 1: exit i: rem DOS found
1834      endif
1836     endfor i
1838  = 2
1840    for i = 1 to 8
1842     if len(NFA_USE$(i)) then
1844      if WIRX%(s$, NFA_USE$(i)): f = 1: exit i: rem NFA found
1846     endif
1848    endfor i
1850  endsel
1852 endif
1854 :
1856 if f = 0 then
1858  sep$ = '/'
1860  s$ = WPARSE$('//*;////*;~//*'): rem Try pattern of Linux path
1862 endif
1864 :
1866 ret s$
1868 enddef GetFSSpec$
1870 :
1872 :
1874 rem + ------------------------------------------------------------------------ +
1876 rem |<                         Command Line and Setup                         >|
1878 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
1880 rem |                                                                          |
1882 rem + ------------------------------------------------------------------------ +
1884 :
1886 def fn GetCmd(cl$)
1888 loc t, t$(200)
1890 rem GLOBal ddir$, filt$, sort%, palette, retadd
1892 :
1894 rem     Defaults
1896 drv%    =  4    : rem Anchor drive number
1898 ddir$   = ''    : rem Start directory
1900 filt$   = '*'   : rem Filter pattern (WILD)
1902 sort%   =  1: azza% = 1: rem Simple sort criteria
1904 palette =  0    : rem Palette
1906 retadd  =  0    : rem Return memory address pointing to min 202b
1908 xpos%   = -1    : rem Start position x
1910 ypos%   = xpos% : rem                y
1912 ftitle  =  0    : rem Title in effect flag
1914 :
1916 if len(cl$) = 0: ret 0
1918 :
1920 rem     Get working device if different from configured default
1922 t$ = Getent$("D")
1924 if VALID%(3, t$) then
1926  t$ = t$(1)
1928  if t$ instr '12345678': drv% = t$
1930 endif
1932 :
1934 rem     Get Home Directory
1936 t$ = Getent$("C")
1938 if t$ <> '' then
1940  if not WIRX%(WPARSE$("*_Pox?obj"), t$) then
1942   if t$(len(t$)) <> '_': t$ = t$ & '_'
1944   t$ = t$ & 'Pox_obj'
1946  endif
1948  if not ftest(t$) then
1950   popfnm$ = t$: poxx = 0
1952   rem Else popfnm$ as configured
1954  endif
1956 endif
1958 :
1960 rem     Get pointer position
1962 t$ = Getent$("X")
1964 if VALID%(3, t$): xpos% = t$
1966 t$ = Getent$("Y")
1968 if VALID%(3, t$): ypos% = t$
1970 :
1972 rem     Get number of lines to display
1974 t$ = Getent$("Z")
1976 if VALID%(3, t$) then
1978  wsize% = t$
1980  if wsize% then
1982   if wsize% < 3: wsize% = 3
1984   fstat% = (scr_ylim(#cw) - ymin% - 33) / 11
1986   if wsize% > fstat%: wsize% = fstat%
1988   wsize% = wsize% + 1
1990  endif
1992 else
1994  wsize% = 0
1996 endif
1998 :
2000 rem     Get extension separator translation status
2002 t$ = Getent$("E")
2004 if len(t$) then
2006  fix% = 0
2008  if mach% = 30 then
2010   if QPC_VER$ > '4.05' and t$ =='on': fix% = 1
2012  endif
2014 endif
2016 :
2018 rem     Get start position (Name)
2020 t$ = Getent$("N")
2022 if WIRX%(dosspec$, t$):  ddir$ = t$
2024 :
2026 rem     Get file name filter
2028 t$ = Getent$("F")
2030 if len(t$): filt$ = t$
2032 filtp$ = WPARSE$(filt$): rem Filter pattern (WILD)
2034 fstat% = 0
2036 :
2038 rem     Get sort order
2040 t$ = Getent$("S")
2042 if len(t$) = 1 then
2044  sort% = t$(1) instr 'NDLA'
2046  if code(t$(1)) && 32: azza% = -1: else: azza% = 1
2048 endif
2050 sorts%(sort%) = 128
2052 :
2054 rem     Do palette
2056 t$ = Getent$("P")
2058 if t$ <> '' then
2060  er = ValidHex(t$, palette)
2062  if er < 0: ret er
2064 endif
2066 :
2068 rem     Get return address or use stuffer buffer
2070 t$ = Getent$("R")
2072 if t$ <> '' then
2074  if len(t$) = 8: t = hex(t$)
2076  if t >= 0 and not odd(t): retadd = t
2078 endif
2080 :
2082 rem     Get Title
2084 t$ = Getent$("T")
2086 if t$ <> '': title$ = t$: ftitle = 1
2088 :
2090 ret 0
2092 enddef GetCmd
2094 :
2096 def fn Getent$(c$)
2098 loc p%, t$(200)
2100 rem Caller's cl$
2102 rem Given the character get the entry
2104 rem /C [<spaces>] ["|'] <entry> ["|'] <space> | / | <eol>
2106 :
2108 p% = '/' & c$ instr cl$
2110 if p% = 0: ret ''
2112 t$ = DETAB$(cl$(p% + 2 to len(cl$)))
2114 p% = ' /' instr t$
2116 if p% > 0: t$ = t$(1 to p%): else: p% = len(t$)
2118 for p% = len(t$) to 1 step -1
2120  if not t$(p%) instr ' /': exit p%
2122 endfor p%
2124 :
2126 t$ = t$(1 to p%)
2128 if len(t$) > 1 then
2130  p% = t$(1) instr quote$
2132  if p% then
2134   if (t$(len(t$)) instr quote$) = p% then
2136    t$ = t$(2 to len(t$) - 1)
2138   endif: endif: endif
2140 ret t$
2142 enddef Getent$
2144 :
2146 :
2148 def proc PalSet
2150 rem GLOBal palette
2152 if palette > 3 then
2154  sp_jobownpal -1, palette: rem Use calling job's private palette
2156 else
2158  sp_jobpal -1, palette: rem Use system palette
2160 endif
2162 enddef PalSet
2164 :
2166 :
2168 rem + ---------------------------------------------------------------------- +
2170 rem |<                              Quick Select                            >|
2172 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
2174 rem | Presents a list of items for selection                                 |
2176 rem | px% / py% = menu origen relative to outline                            |
2178 rem | qsld$     = array of display texts                                     |
2180 rem | qsl$      = array of help texts                                        |
2182 rem | qslst%    = display item statuses 0 => ava, 16 => una, 128 => sel      |
2184 rem | flag%     = option bits set: #0 => no del, #1 => multi select          |
2186 rem |                       unset: #0 => del ok, #1 => help text on HIT      |
2188 rem | V0.10, pjw, 2oi5                                                       |
2190 rem + ---------------------------------------------------------------------- +
2192 :
2194 DEFine fn QuickSel(px%, py%, qsld$, qsl$, qslst%, flag%)
2196 loc ml, cm, k, ix%, s%, sx%, sy%, cnt%, prec%(15)
2198 loc chsx%, chsy%, chpx%, chpy%
2200 :
2202 cm = fopen('con_')
2204 flim#cm; chsx%, chsy%, chpx%, chpy%
2206 :
2208 cnt% = dimn(qsld$)
2210 sy%  = (cnt% + 1) * 11 + 2
2212 sx%  = dimn(qsld$(0)) * 6 + 6
2214 if sy% > (chsy% - py%) then
2216  sy% = chsy% - py% - 11
2218  sx% = sx% + 8
2220 endif
2222 :
2224 MDRAW#cm; MN_QSEL, chpx% + px%, chpy% + py%, sx%, sy%
2226 MAWSETUP#cm, 1, qsld$
2228 MSTAT#cm, 1, qslst%
2230 MAWDRAW#cm; 1
2232 :
2234 s% = 0
2236 REPeat ml
2238  k = MCALL(#cm; k, s%): PVAL#cm; prec%
2240  SELect ON k
2242   = -2: REMark Del
2244      rem if flag% && 1: QuickDel: else: Burp
2246   = -1: ix% = 0: exit ml: rem Quit
2248   = REMAINDER
2250     IF k <= mencon: next ml
2252     ix% = ((k - 1) / mencon) - 1
2254     if ix% = 0: ix% = -prec%(5): exit ml
2256     IF prec%(5) = 1 THEN
2258      REMark HIT
2260      if flag% && 2 then
2262       s% = mstat%(#cm, k)
2264      else
2266       IF LEN(qsl$(ix%)) > 0: Popup qsl$(ix%): else: Popup qsld$(ix%)
2268      endif
2270      next ml
2272     END IF
2274     EXIT ml
2276  END SELect
2278 END REPeat ml
2280 if flag% && 1: mstat#cm\ 1, qslst%
2282 MCLEAR#cm: CLOSE#cm
2284 ret ix%
2286 END DEFine QuickSel
2288 :
2290 :
2292 DEFine PROCedure Popup(txt$)
2294 rem GLOBal popfnm$, poxx
2296 if poxx = 0 then
2298  ew popfnm$; '/P' & hex$(palette, 32) & '/T' & txt$
2300  rem rdpt#cw%, irt%
2302 endif
2304 END DEFine Popup
2306 :
2308 :
2310 def proc Burp: beep 2000, 200: enddef Burp
2312 def proc Ping: beep 2000, 2: enddef Ping
2314 :
2316 :
2318 rem + ------------------------------------------------------------------------ +
2320 rem |<                                ValidHex                                >|
2322 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
2324 rem |       Validate a hex string and return its decimal value or error        |
2326 rem |                                                                          |
2328 rem | Returns hex value in r.hx parameter!                                     |
2330 rem | A valid hex number is of the form                                        |
2332 rem |    [$]<hex digit>[<hex digit>] * 7                                       |
2334 rem | Where [] => optional, and hex digits are 0..9, A..F, a..f                |
2336 rem | The first non-hex charcter in an otherwise valid number terminates the   |
2338 rem | the number but does not invalidate it!                                   |
2340 rem | Numbers with more than 8 hex digits are truncated, but not invalidated!  |
2342 rem + ------------------------------------------------------------------------ +
2344 rem | V0.04, pjw, 2019 Dec 16, rewrite                                         |
2346 rem + ------------------------------------------------------------------------ +
2348 :
2350 DEFine FuNction ValidHex(hx$, r.hx)
2352 LOCal i%, d%, e%
2354 d% = (('$' INSTR hx$) = 1) + 1
2356 IF LEN(hx$) < d%: RETurn -15
2358 e% = d% + 7
2360 IF e% > LEN(hx$): e% = LEN(hx$)
2362 FOR i% = d% TO e%
2364  IF NOT hx$(i%) INSTR '0123456789ABCDEF': e% = i% - 1: EXIT i%
2366 END FOR i%
2368 IF e% < d%: RETurn -15
2370 r.hx = HEX(hx$(d% TO e%))
2372 RETurn 0
2374 END DEFine ValidHex
2376 :
2378 :
